/*

  
    -------------------------------------------
              __
    PACMAN   //./ . . . . .
             \\_\
    -------------------------------------------
    
    Simple PacMan (on MignonKit)
    -------------------------------------------
    
    
    version o.7
    by game@la1n.ch
    
    
    datastructures: arrays
    
    - playfield [walls, pills]
    - sprites { pacman, ghosts }
    - level0-level7
    
    methodes:
    
    - loop [gamestatus]
    -- doGameLoop etc
    
    todo:
    
    - pacman theme melody - is there anybody who has the tunes? or the time to import it
    -- add melody
    --  uncomment "play_melody" in startIntro()
      
      
*/
#include <gamekit_2_1.h>

#include <avr/pgmspace.h>

// game
int gamestatus=0; // 0: intro* / 1: menu* / 2: play game /3: die / 4: level done / 5: game won / 6: gameover

// * not yet implemented

// intro

uint8_t introscreen[5][34]  ={
  
	5, 5 ,5 ,0 ,5 ,5 ,5 ,0 ,5, 5, 5, 0, 5, 5, 5, 5, 5, 0, 5, 5, 5, 0, 5, 5, 5, 0, 0, 0, 5, 5, 0, 0, 0, 0,
	5, 0 ,5 ,0 ,5 ,0 ,5 ,0 ,5, 0, 0, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 0, 5, 5, 5, 5, 0, 0, 0,
	5, 5 ,5 ,0 ,5 ,5 ,5 ,0 ,5, 0, 0, 0, 5, 0, 0, 0, 5, 0, 5, 5, 5, 0, 5, 0, 5, 0, 0, 5, 5, 4, 4, 0, 1, 0,
	5, 0 ,0 ,0 ,5 ,0 ,5 ,0 ,5, 5, 5, 0, 5, 0, 0, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 0, 0, 5, 5, 0, 0, 0, 0,
	0, 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};





// ingame
int level=0;
int lifes=3;

// display ... // PROGMEM
uint8_t screen[5][7]  ={
	0 ,0 ,0 ,0 ,0 ,0 ,1 ,
	1 ,0 ,0 ,0 ,0 ,0 ,2 ,
	2 ,0 ,0 ,0 ,0 ,0 ,3 ,
       15 ,0 ,0 ,0 ,0 ,0 ,4 ,
	0 ,0 ,0 ,0 ,0 ,0 ,5 
	};

// playfield (+2 pixel in x / + 2 pixel in y)
// playground ingame
uint8_t playfield[7][9]  ={
  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,5 ,1 ,1 ,1 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};

// lastlevel
uint8_t lastLevel=6; // exit done

// enemies
uint8_t levelEnemies[ ]= {2,3,3,3,3,4,4,2};

// speed
long levelSpeed[ ]= {900,900,800,800,700,600,400};


// levels
uint8_t level0[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,5 ,1 ,1 ,1 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};
uint8_t level1[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,5 ,1 ,1 ,1 ,5 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};
uint8_t level2[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,5 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,5 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};

uint8_t level3[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,5 ,1 ,5 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,5 ,1 ,5 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};
uint8_t level4[7][9]  ={  
	5, 5 ,5 ,0 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,5 ,0 ,5 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,5 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,1 ,5 ,1 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,1 ,1, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5
	};
uint8_t level5[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,0,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,5 ,5,
	5, 1 ,5 ,5 ,5 ,1 ,1 ,1 ,5,
	5, 1 ,1 ,1 ,5 ,1 ,5 ,1 ,5,  // warp zone
        5, 1 ,5 ,1 ,5 ,5 ,1 ,1 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,5, 5,
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,0
	};
uint8_t level6[7][9]  ={  
	5, 5 ,5 ,5 ,5 ,5 ,5 ,5 ,5,
	5, 1 ,1 ,1 ,1 ,1 ,1 ,1 ,5,
	5, 1 ,5 ,5 ,1 ,5 ,5 ,1 ,5,
	5, 1 ,1 ,5 ,1 ,5 ,1 ,1 ,5,  // warp zone
        5, 1 ,5 ,5 ,5 ,5 ,5 ,1 ,5,
	5, 1 ,1 ,5 ,0 ,5 ,1 ,1, 5,
	5, 5 ,5 ,5 ,0 ,5 ,5 ,5 ,5
	};

// display ... // PROGMEM
uint8_t nextlevelscreen[5][7]  ={
	0 ,5 ,5 ,0 ,0 ,5 ,0 ,
	0 ,5 ,5 ,5 ,0 ,5 ,0 ,
	0 ,5 ,5 ,5 ,0 ,5 ,0 ,
        0 ,5 ,5 ,0 ,0 ,5 ,0 ,
	0 ,0 ,0 ,0 ,0 ,0 ,21 
	};


// game over
uint8_t gameoverscreen[5][34]  ={
  
	5, 5 ,5 ,0 ,5 ,5 ,0 ,0 ,5, 5, 0, 5, 5, 0, 5, 5, 5, 0, 5, 5, 5, 0, 5, 0, 5, 0, 5, 5, 5, 0, 5, 5, 0, 0,
	5, 0 ,0 ,0 ,5 ,0 ,5 ,0 ,5, 0, 5, 0, 5, 0, 5, 0, 0, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 0, 0, 5, 5, 5, 0,
	5, 5 ,5 ,0 ,5 ,5 ,5 ,0 ,5, 0, 0, 0, 5, 0, 5, 5, 0, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 5, 0, 0, 5, 0, 5, 0,
	5, 5 ,5 ,0 ,5 ,0 ,5 ,0 ,5, 0, 0, 0, 5, 0, 5, 5, 5, 0, 5, 5, 5, 0, 0, 5, 0, 0, 5, 5, 5, 0, 5, 0, 5, 0,
	0, 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};

// game won
uint8_t gamewonscreen[5][34]  ={
  
	0, 5, 0 ,5 ,0 ,5 ,5 ,5 ,0 ,5, 0, 5, 0, 5, 5, 5, 0, 5, 0, 5, 5, 0, 0, 5, 0, 5, 5, 5, 0, 5, 0, 5, 0, 0, 
	0, 5, 0 ,5 ,0 ,5 ,0 ,5 ,0 ,5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 0, 5, 0, 0, 5, 0, 0, 0, 0, 
	0, 5, 5 ,5 ,0 ,5 ,0 ,5 ,0 ,5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 5 ,0 ,0 ,5 ,5 ,5 ,0 ,5, 5, 5, 0, 5, 5, 5, 0, 5, 0, 5, 5, 5, 0, 5, 0, 0, 5, 0, 0, 5, 0, 0, 0, 0, 
	0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};


// sprites ... 
/*
  direct:
  1 left
  2 right
  
  3 up
  4 down

*/
int activeSprites=3; // 0: for the pacman 1:+the enemies
uint8_t sprites[][9] =
{
  // x,y,type,direction, direction1test, direction2test, direction3test, direction4test, countpossibledirections
  0,0,0,-1, 0,0,0,0,0,  // 2,3
  2,3,1,3, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,1,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
  2,3,2,4, 0,0,0,0,0,
};

// distance
uint8_t distanceTemp[]= { 0,0,0,0,0  };

// play
int playerWishedDirections=1;
int oldplayerWishedDirections=1;

// sound
/*
    SOUND
*/
const uint16_t melody[][2] PROGMEM =
{
  //------------ 1
  m_set_volume, LOUD,
  m_8_dot_note, m_D4,
  m_rest      , m_16_rest,
  m_8_dot_note, m_D4,
  m_rest      , m_16_rest,
  m_8_dot_note, m_D4,
  m_rest      , m_16_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  //---------- 2
  m_8_dot_note, m_D4,
  m_rest      , m_16_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  m_4_dot_note, m_D4,
  m_rest      , m_8_rest,
  //---------- 3
  m_8_dot_note, m_A4,
  m_rest      , m_16_rest,
  m_8_dot_note, m_A4,
  m_rest      , m_16_rest,
  m_8_dot_note, m_A4,
  m_rest      , m_16_rest,
  m_8_dot_note, m_Bb4,      //this is the 23th event
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  //----------- 4
  m_8_dot_note, m_Ct4,
  m_rest      , m_16_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  m_4_dot_note, m_D4,
  m_rest      , m_8_rest,
  //----------- 5
  m_8_dot_note, m_D5,
  m_rest      , m_16_rest,
  m_8_note    , m_D4,
  m_rest      , m_16_rest,
  m_16_note   , m_D4,
  m_8_note    , m_D5,
  m_rest      , m_8_rest,
  m_8_note    , m_Ct5,
  m_rest      , m_16_rest,
  m_16_note    , m_C5,
  //------------ 6
  m_16_note   , m_Bb4,
  m_16_note   , m_At4,
  m_8_note    , m_Bb4,
  m_rest      , m_8_rest,
  m_16_note   , m_Dt4,
  m_rest      , m_16_rest,
  m_8_note    , m_Gt4,
  m_rest      , m_8_rest,
  m_8_note    , m_G4,
  m_rest      , m_16_rest,
  m_16_note   , m_Ft4,
  //------------ 7
  m_16_note   , m_F4,
  m_16_note   , m_E4,
  m_8_note    , m_F4,
  m_rest      , m_8_rest,
  m_16_note   , m_Bb3,
  m_rest      , m_16_rest,
  m_8_note    , m_Ct4,
  m_rest      , m_8_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_C4,
  //------------ 8  
  m_8_dot_note, m_F4,
  m_rest      , m_16_rest,
  m_8_note    , m_D4,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  m_4_dot_note, m_A4,
  m_rest      , m_8_rest,
  //------------ 9
  m_8_dot_note, m_D5,
  m_rest      , m_16_rest,
  m_8_note    , m_D4,
  m_rest      , m_16_rest,
  m_16_note   , m_D4,
  m_8_note    , m_D5,
  m_rest      , m_8_rest,
  m_8_note    , m_Ct5,
  m_rest      , m_16_rest,
  m_16_note   , m_C5,
  //------------ 10
  m_16_note   , m_Bb4,
  m_16_note   , m_At4,
  m_8_note    , m_Bb4,
  m_rest      , m_8_rest,
  m_16_note   , m_Dt4,
  m_rest      , m_16_rest,
  m_8_note    , m_Gt4,
  m_rest      , m_8_rest,
  m_8_note    , m_G4,
  m_rest      , m_16_rest,
  m_16_note   , m_Ft4,
  //------------ 11
  m_16_note   , m_F4,
  m_16_note   , m_E4,
  m_8_note    , m_F4,
  m_rest      , m_8_rest,
  m_16_note   , m_Bb3,
  m_rest      , m_16_rest,
  m_8_note    , m_Ct4,
  m_rest      , m_8_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  //------------ 12
  m_8_dot_note, m_D4,
  m_rest      , m_16_rest,
  m_8_note    , m_Bb3,
  m_rest      , m_16_rest,
  m_16_note   , m_F4,
  m_4_dot_note, m_D4,
  m_stop      , 0
};

// setup
void setup(){

   Serial.begin(9600);
   gamekit.Begin();
   
   // start up
   gamestatus=0;
   
   Serial.println("---------------------");
   Serial.println("pac man o.7");
   Serial.println("---------------------");
   Serial.println("we love serial, ");
   Serial.println("but we hate 'i love ny'-tshirts ");
   Serial.println("");
   Serial.println("code by t00cg");
   Serial.println("");
   Serial.println("greetings to olaf");
   Serial.println("");

  // start intro
  startIntro();
 }
   
// milli seconds for sprites / pacman
long mils=0; 
long milsPacman=0; 
int stocked=0;

// loop
void loop()
{
  if (gamestatus==0) { doIntroLoop(); };
  if (gamestatus==2) { doGameLoop(); };
  if (gamestatus==3) { doGameLoopDie(); };
  if (gamestatus==4) { doGameLevelDone(); };
  if (gamestatus==5) { doGameDone(); };
  if (gamestatus==6) { doLoopGameOver(); };
}

// intro Loop
int introPosition=0;

// start intro .. 
void startIntro()
{
   // start sound here
   // gamekit.play_melody((uint16_t *) melody);

   gamestatus=0;
}

void doIntroLoop()
{
  
   if(gamekit.button_pressed(butt_UP)) {  resetLevelObjects();startGame(); }
   if(gamekit.button_pressed(butt_DOWN)) { resetLevelObjects(); startGame(); }
   if(gamekit.button_pressed(butt_LEFT)) { resetLevelObjects(); startGame(); }
   if(gamekit.button_pressed(butt_RIGHT)) { resetLevelObjects(); startGame(); }
   if(gamekit.button_pressed(butt_FUNCA)) { resetLevelObjects(); startGame(); }
   if(gamekit.button_pressed(butt_FUNCB)) { resetLevelObjects(); startGame(); }


   if (millis()-mils>750)
   {
       mils=millis();
       
       // show
       for (int z=0;z<5;z++) 
       {  
         for (int zz=0;zz<7;zz++)
         {
             // anti al
             int rgb=introscreen[z][zz+introPosition];
             // if (zz>0) { if (rgb==0) { if (introscreen[z][zz+introPosition-1]==5) { rgb=1; }   }  }
             gamekit.set_pixel(z, zz, rgb); 
          }
       }  
       
       introPosition=introPosition+1;
       if (introPosition>27) introPosition=0;
  
   }

}



  // start game now
  void startGame()
  {
      tuneClick();
 
     level=0;
      lifes=3;
     
     loadLevel(level);
     
     gamestatus=2;
  }

// game loop 
void doGameLoop(){
  // debugging
  // Serial.println("next loop");

  // level enmies
  activeSprites=levelEnemies[level];


 // Serial.println("");
 // Serial.print("Level ");
 // Serial.println(level,DEC);

  /*
      Do Sprite Behavior   
  */
  // Pac Man behavior
  // MENU
   // A
  if(gamekit.button_pressed(butt_FUNCA))
  {
    // restart
    // sprites[0][1]=sprites[0][1]-1;
  }

// PLAYER
 if(gamekit.button_pressed(butt_UP))
  {
         playerWishedDirections=1;
  }
  
  if(gamekit.button_pressed(butt_DOWN))
  {
         playerWishedDirections=2;
  }  
  
  
 if(gamekit.button_pressed(butt_LEFT))
  {
         playerWishedDirections=3;
   
  }
  
  if(gamekit.button_pressed(butt_RIGHT))
  {
    playerWishedDirections=4;
    
  }  
  
  // warp zone
  if (false)
  {
    if ((sprites[0][0]==2)&&(sprites[0][1]==-1)) { sprites[0][1]=6; }
    if ((sprites[0][0]==2)&&(sprites[0][1]==7)) { sprites[0][1]=2; }
  }
  
  // eat now
  if (getPlayFieldValue(sprites[0][0],sprites[0][1])==1)
  {
    setPlayFieldValue(sprites[0][0],sprites[0][1],0);
    tuneEat(); //  LOUD SILENT
  }
  
  // die?
  int died=0;
  // best sprite collision ever :-) 
   for (int z=1;z<activeSprites;z++)
   {
     if ((sprites[z][0]==sprites[0][0])
        &&
        (sprites[z][1]==sprites[0][1]))
     {
        died=1;
        // Serial.println("just died!");
     }
  }
    
  // died!!!
  if (died==1)
  { 
      tuneDie();
      
      int gameoverFlag=doGameLoopDieInit();
      if (gameoverFlag==1) return;
      
      resetLevelObjects();
      
      gamestatus=3;
      
      return;
  }
  
  // all pills away?
  int countedPills=0;
  
  for (int u=0;u<7;u++)
  {
    for (int uu=0;uu<5;uu++)
    {
      if (getPlayFieldValue(uu,u)==1)
      {
         countedPills++; 
      }
    }
  }
  // Serial.print("  ");
  // Serial.println(countedPills,DEC);
  if (countedPills==0) {     
    gamekit.play_tone(261, 50, LOUD); //  LOUD SILENT
   doLoadNextLevel(); 
   return;
}
  
  // do the movement
  if ((millis()-milsPacman>500)||(oldplayerWishedDirections!=playerWishedDirections))
  {
     // playerWishedDirections
     int spielerPosX=sprites[0][0];
     int spielerPosY=sprites[0][1];
     int spielerDirect=sprites[0][3];

    // check wished perspective is possible?
    if (playerWishedDirections==1)
    {
      if (getPlayFieldValue(spielerPosX-1,spielerPosY)!=5)
      {
          spielerDirect=playerWishedDirections;
          sprites[0][3]=spielerDirect;
      }
    }
    if (playerWishedDirections==2)
    {
      if (getPlayFieldValue(spielerPosX+1,spielerPosY)!=5)
      {
          spielerDirect=playerWishedDirections;
          sprites[0][3]=spielerDirect;
      }
    }
     if (playerWishedDirections==3)
    {
      if (getPlayFieldValue(spielerPosX,spielerPosY-1)!=5)
      {
          spielerDirect=playerWishedDirections;
          sprites[0][3]=spielerDirect;
      }
    }
      if (playerWishedDirections==4)
    {
      if (getPlayFieldValue(spielerPosX,spielerPosY+1)!=5)
      {
          spielerDirect=playerWishedDirections;
          sprites[0][3]=spielerDirect;
      }
    }
    
     // do it
     stocked=0;
     
     if (spielerDirect==1)
     {
        if (getPlayFieldValue(spielerPosX-1,spielerPosY)!=5)
        {
          spielerPosX=spielerPosX-1;
        }
        else
        {
          stocked=1; 
        }
     }
     if (spielerDirect==2)
     {
        if (getPlayFieldValue(spielerPosX+1,spielerPosY)!=5)
        {
          spielerPosX=spielerPosX+1;
        }
        else
        {
           stocked=1; 
        }
     }
     if (spielerDirect==3)
     {
        if (getPlayFieldValue(spielerPosX,spielerPosY-1)!=5)
        {
          spielerPosY=spielerPosY-1;
        }
        else
        {
           stocked=1; 
        }
     }     
     if (spielerDirect==4)
     {
        if (getPlayFieldValue(spielerPosX,spielerPosY+1)!=5)
        {
          spielerPosY=spielerPosY+1;
        }
        else
        {
           stocked=1; 
        }
     }     
     
     if (stocked==0)
     {
        tuneWalk(); 
     }
     
     sprites[0][0]=spielerPosX;
     sprites[0][1]=spielerPosY;
     sprites[0][3]=spielerDirect;
         
     milsPacman=millis();   
  }
  oldplayerWishedDirections=playerWishedDirections;
  
  // Ghosts behavior
  // milis  
  if (millis()-mils>levelSpeed[level])
  {
    // ...
    // Serial.print("ghost go on");
    
    // do it ..
    // enemies
    for (int z=1;z<activeSprites;z++)
    {
      // set pixel
  //     SetPixel(sprites[z][0], sprites[z][1], 19);
     
     // do sprite
     // doSprite(z);
     int x=sprites[z][0];
     int y=sprites[z][1];
     
     int type=sprites[z][2];
     int direct=sprites[z][3];
     
     // check out the reality out there
         /*
        cases:
        
        2 open ways: go the way
        3-4 open ways: decisions
        
      */
     // check all directions 
     sprites[z][4]=0; // direction 1
     sprites[z][5]=0; // direction 2
     sprites[z][6]=0; // direction 3
     sprites[z][7]=0; // direction 4
     sprites[z][8]=0; // directionFree
 
      
     // check them all
     if (getPlayFieldValue(x,y-1)!=5) { sprites[z][4]=1;  sprites[z][8]= sprites[z][8]+1; }
     if (getPlayFieldValue(x,y+1)!=5) { sprites[z][5]=1;  sprites[z][8]= sprites[z][8]+1; }
     if (getPlayFieldValue(x-1,y)!=5) { sprites[z][6]=1;  sprites[z][8]= sprites[z][8]+1; }
     if (getPlayFieldValue(x+1,y)!=5) { sprites[z][7]=1;  sprites[z][8]= sprites[z][8]+1; }
     
     /*
         *
        * *
         *
     */
    if (false) debugMatrix(sprites[z][4],sprites[z][5],sprites[z][6],sprites[z][7]);
     //  delay(1000);
     
     // set next direction here

     if (sprites[z][8]<2)
     {
        // Serial.println("way: error no way");
     }


     if (sprites[z][8]==2)
     {
        // Serial.println("way: go on");

       int newdirect=direct;
        // next direction 
       if (direct==1) // left
       {
          if (sprites[z][4]==1) { newdirect=1; }  
          
          if (sprites[z][6]==1) { newdirect=3; }  
          if (sprites[z][7]==1) { newdirect=4; }  
       }
       if (direct==2) // right
       {
          if (sprites[z][5]==1) { newdirect=2; }  
          
          if (sprites[z][6]==1) { newdirect=3; }  
          if (sprites[z][7]==1) { newdirect=4; }  
       }
       if (direct==3) // up
       {
          if (sprites[z][4]==1) { newdirect=1; }  
          if (sprites[z][5]==1) { newdirect=2; }  
          
          if (sprites[z][6]==1) { newdirect=3; }  
       }
       if (direct==4) // down
       {
          if (sprites[z][4]==1) { newdirect=1; }  
          if (sprites[z][5]==1) { newdirect=2; }  
          
          if (sprites[z][7]==1) { newdirect=4; }  
       }
 
      // new direct
      sprites[z][3]=newdirect;

      // Serial.println(direct,DEC);
       
     }
     
     // decide now ..
     if (sprites[z][8]>2)
     {
          // Serial.println("way: decision point");
 
 //       Serial.println(direct,DEC);
          
          // pacman lives
          if (type==0)
          {
              // use playerWishedDirections
              int ux=sprites[z][0];
              int uy=sprites[z][1]; // (getPlayFieldValue(x,y-1)!=5)
              
              if (playerWishedDirections==1)  { ux=sprites[z][0]-1; uy=sprites[z][1]; }
              if (playerWishedDirections==2)  { ux=sprites[z][0]+1; uy=sprites[z][1]; }
              if (playerWishedDirections==3)  { ux=sprites[z][0]; uy=sprites[z][1]-1; }
              if (playerWishedDirections==4)  { ux=sprites[z][0]; uy=sprites[z][1]+1; }
          
              if (getPlayFieldValue(ux,uy)!=5) 
              {
                   // possible direction
                  sprites[z][3]=playerWishedDirections; 
              }
 
         }
 

         // random  
         if (type==1)
         {
            // next random direction 
            int foundNewDirection=0;
            do
            {
               int newDir=random(1,4);
           
               // Serial.println(newDir,DEC); 
            
               if (sprites[z][3+newDir]==1) // possible to go there?
               if (newDir!=direct) // not the same direction as you come from
               {
                    // take this
                    foundNewDirection=1;
                    sprites[z][3]=newDir;
               }
           
            }
            while(foundNewDirection==0);

          // Serial.print("--- ");
          // Serial.println(sprites[z][3],DEC); 
          
         } // / type
         
         // follow       
         if (type==2)
         {
          // Serial.print("--- type 2 ||||| ");
            
           // distanceTemp
            distanceTemp[0]=400;
            distanceTemp[1]=400;
            distanceTemp[2]=400;
            distanceTemp[3]=400;
            
            // look at all possible movements
            for (int o=0;o<4;o++)
            {
                int ix=-1; 
                int iy=-1; ;
                
                // left
                if (o==0)
                {
                    ix=sprites[z][0];
                    iy=sprites[z][1]-1;
                }
                if (o==1)
                {
                    ix=sprites[z][0];
                    iy=sprites[z][1]+1;
                }
                if (o==2)
                {
                    ix=sprites[z][0]-1;
                    iy=sprites[z][1];
                }
                if (o==3)
                {
                    ix=sprites[z][0]+1;
                    iy=sprites[z][1];
                }
  
                // field value
                if (getPlayFieldValue(ix,iy)!=5)
                {
                      distanceTemp[o]=getDistanceToPlayer(sprites[0][0],sprites[0][1],ix,iy); 
                }   

              // Serial.print(" / ");
              // Serial.print(distanceTemp[o],DEC);
              // Serial.print(" ");
            }
            // Serial.println("");                
            
            
            // search ...
            int near=3000;
            int nearIndex=-1;
            for (int o=0;o<4;o++)
            {
                if (distanceTemp[o]!=400)
                if (near>distanceTemp[o])
                 {
                    nearIndex=o;
                    near=distanceTemp[o];
                 }   
            }
         /*   
            Serial.print("follow .. near: ");
            Serial.println(near,DEC);
            Serial.println(" ");
            Serial.println(nearIndex,DEC);
           */ 
            // take this movement
            sprites[z][3]=nearIndex+1;
          
         } // / type
         
         
         // fear it ...
         
         
// sprites[z][3]=200;

        // hunt the enemy!

        // flew !
 //    Serial.println("");
 
 
   }

  // new direct
  direct=sprites[z][3];

     // a little step for pacman
     // a big for the game pacman
     int stocked=0;
     
     
     // behavior
     // 1 left 2 right 3 up 4 down
     if (direct==1) 
     {    
        // check in front of you ...
        if (getPlayFieldValue(x,y-1)!=5)
        {
           sprites[z][1]=sprites[z][1]-1;
        }
      }
      else
     if (direct==2) 
     {    
        // check in front of you ...
        if (getPlayFieldValue(x,y+1)!=5)
        {
           sprites[z][1]=sprites[z][1]+1;
        }
      }  
     else
     if (direct==3) 
     {    
        // check in front of you ...
        if (getPlayFieldValue(x-1,y)!=5)
        {
           sprites[z][0]=sprites[z][0]-1;
        }
      }     
      else
     if (direct==4) 
     {    
        // check in front of you ...
        if (getPlayFieldValue(x+1,y)!=5)
        {
           sprites[z][0]=sprites[z][0]+1;
        }
      }          
      
 

//   Serial.print("New direction");
//   Serial.println(sprites[z][3],DEC);
     
     // flew
   }
  
  
 
  
   // store for next round
   mils=millis();
    
  }
  
  /*
     
     Generate Display
     (Merge the different layers)
 
 */ 
  
  // Clear Pixels
  clearPixels();
  
  // add playfield
  
    // ghosts
  
 // show
   int value=0;
   int rgb=0;
   for (int z=0;z<5;z++) 
   {  
     for (int zz=0;zz<7;zz++)
     {
         value=playfield[z+1][zz+1];
         rgb=0;
         if (value>0)
         {
           // wall
           if (value==5) rgb=15;
           // pille           
           if (value==1) rgb=2;
           if (value==2) rgb=1;
         }
         if (rgb>0)
         {
            screen[z][zz]=rgb;
         }       
     }
   }   


  // ghosts visuals
  for (int z=0;z<activeSprites;z++)
  {
    // set pixel
//    gamekit.set_pixel(sprites[z][0], sprites[z][1], 19); // 0-15 / 15-20 blink
    // SetPixel(sprites[z][0], sprites[z][1], 10); // 19

    if (sprites[z][2]==0) SetPixel(sprites[z][0], sprites[z][1], 20); // pacman
    
    if (sprites[z][2]==1) SetPixel(sprites[z][0], sprites[z][1], 18); // 19
    if (sprites[z][2]==2) SetPixel(sprites[z][0], sprites[z][1], 19); // 19

  }

  // player  
  // set the pixel
  SetPixel(sprites[0][0],sprites[0][1],21);  

 // update display 
 showPixels();
 
}

// do Load Next Level
void doLoadNextLevel()
{
    level=level+1;
    if (level>lastLevel)
    {
       doGameDoneInit();
       level=0; 
       return;
    }

    loadLevel(level);    

    gamestatus=4;
}

  // load Level
  void loadLevel( int level )
  {
     //// load level
     for (int z=0;z<7;z++) 
       {  
         for (int zz=0;zz<9;zz++)
         {
            playfield[z][zz]=level0[z][zz]; 
            if (level==0)  { playfield[z][zz]=level0[z][zz]; }
            if (level==1)  { playfield[z][zz]=level1[z][zz]; }
            if (level==2)  { playfield[z][zz]=level2[z][zz]; }
            if (level==3)  { playfield[z][zz]=level3[z][zz]; }
            if (level==4)  { playfield[z][zz]=level4[z][zz]; }
            if (level==5)  { playfield[z][zz]=level5[z][zz]; }
            if (level==6)  { playfield[z][zz]=level6[z][zz]; }
          }
       }  
     
     
  }

// level done
void doGameLevelDone()
{
  
   if(gamekit.button_pressed(butt_UP)) {  resetLevelObjects(); gamestatus=2; }
   if(gamekit.button_pressed(butt_DOWN)) { resetLevelObjects();  gamestatus=2; }
   if(gamekit.button_pressed(butt_LEFT)) {  resetLevelObjects();  gamestatus=2;}
   if(gamekit.button_pressed(butt_RIGHT)) { resetLevelObjects(); gamestatus=2;}
   if(gamekit.button_pressed(butt_FUNCA)) { resetLevelObjects();   gamestatus=2; }
   if(gamekit.button_pressed(butt_FUNCB)) { resetLevelObjects();   gamestatus=2; }


   if (millis()-mils>750)
   {
       mils=millis();
       
       // show
       for (int z=0;z<5;z++) 
       {  
         for (int zz=0;zz<7;zz++)
         {
             // anti al
             int rgb=nextlevelscreen[z][zz];
             gamekit.set_pixel(z, zz, rgb); 
          }
       }  
  
   }

}



// gameover
void doLoopGameOver()
{
  
   if(gamekit.button_pressed(butt_UP)) {  startIntro(); }
   if(gamekit.button_pressed(butt_DOWN)) {  startIntro(); }
   if(gamekit.button_pressed(butt_LEFT)) {  startIntro(); }
   if(gamekit.button_pressed(butt_RIGHT)) { startIntro(); }
   if(gamekit.button_pressed(butt_FUNCA)) {  startIntro(); }
   if(gamekit.button_pressed(butt_FUNCB)) {  startIntro(); }


   if (millis()-mils>750)
   {
       mils=millis();
       
       // show
       for (int z=0;z<5;z++) 
       {  
         for (int zz=0;zz<7;zz++)
         {
             // anti al
             int rgb=gameoverscreen[z][zz+introPosition];
             // if (zz>0) { if (rgb==0) { if (introscreen[z][zz+introPosition-1]==5) { rgb=1; }   }  }
             gamekit.set_pixel(z, zz, rgb); 
          }
       }  
       
       introPosition=introPosition+1;
       if (introPosition>27) introPosition=0;
  
   }

}

    int doGameLoopDieInit()
    {
       // 528
       
       // | || |||
       // clear all
       invertPixels();
       delay(500);
       
       // clear all..
       clearDirectScreen(0);
       
       // reset them all
       resetLevelObjects(); 
       
       introPosition=1;
       
       //
       lifes=lifes-1;
       
      // Serial.print(lifes,DEC);
      //  Serial.println("  : lifes");
       
       if (lifes<1) { gamestatus=6; return 1; } // gameover
       else
       {
     
         // add lifes | || |||
         // clear it now ..
   
         for (int s=0;s<lifes;s++)
         {
            gamekit.set_pixel(1,1+s*2,5);
            gamekit.set_pixel(2,1+s*2,5);
            gamekit.set_pixel(3,1+s*2,5);
         }
       } 
      
       gamekit.set_pixel(4,6,20);
       
       return 0;
    }

// game loop die
void doGameLoopDie()
{
  
   if(gamekit.button_pressed(butt_UP)) { resetLevelObjects();  gamestatus=2; }
   if(gamekit.button_pressed(butt_DOWN)) { resetLevelObjects();  gamestatus=2;}
   if(gamekit.button_pressed(butt_LEFT)) { resetLevelObjects();  gamestatus=2;}
   if(gamekit.button_pressed(butt_RIGHT)) { resetLevelObjects();  gamestatus=2; }
   if(gamekit.button_pressed(butt_FUNCA)) { resetLevelObjects();  gamestatus=2; }
   if(gamekit.button_pressed(butt_FUNCB)) { resetLevelObjects();  gamestatus=2; }

}

void doGameDoneInit()
{
   introPosition=0;
   gamestatus=5; 
}

void doGameDone()
{
  
   if(gamekit.button_pressed(butt_UP)) {  startIntro(); }
   if(gamekit.button_pressed(butt_DOWN)) {  startIntro(); }
   if(gamekit.button_pressed(butt_LEFT)) {  startIntro(); }
   if(gamekit.button_pressed(butt_RIGHT)) { startIntro(); }
   if(gamekit.button_pressed(butt_FUNCA)) {  startIntro(); }
   if(gamekit.button_pressed(butt_FUNCB)) {  startIntro(); }

 if (millis()-mils>750)
   {
       mils=millis();
       
       // show
       for (int z=0;z<5;z++) 
       {  
         for (int zz=0;zz<7;zz++)
         {
             // anti al
             int rgb=gamewonscreen[z][zz+introPosition];
             // if (zz>0) { if (rgb==0) { if (introscreen[z][zz+introPosition-1]==5) { rgb=1; }   }  }
             gamekit.set_pixel(z, zz, rgb); 
          }
       }  
       
       introPosition=introPosition+1;
       if (introPosition>27) introPosition=0;
  
   }
}


/*

  SubRoutines

*/


void resetLevelObjects()
{
  // 
  sprites[0][0]=0; 
  sprites[0][1]=0; 
  sprites[0][3]=0; 

  // the rest in the middle  
  for (int zo=1;zo<9;zo++)
  {
     sprites[zo][0]=3;
     sprites[zo][1]=2;  
     sprites[0][3]=1+zo%2; 
  }
}



// Distance to the players
int getDistanceToPlayer(int spielerX, int spielerY, int x, int y)
{
   int retValue=0; 
    
   retValue = (int) sqrt((x-spielerX)*(x-spielerY)+(y-spielerX)*(y-spielerX));
    
   return retValue;
}

// pixels etc
// clearPixels
void clearPixels()
{
 
  // show
   for (int z=0;z<5;z++) 
   {  
     for (int zz=0;zz<7;zz++)
     {
         screen[z][zz]=0;
      }
   }    
}

// SetPixel
void SetPixel( int x, int y, int value  )
{
  screen[x][y]=value;
}


/*
	playfield
*/

void setPlayFieldValue(int x, int y, int value)
{
  playfield[x+1][y+1]=value;
}


int getPlayFieldValue(int x, int y)
{
  return playfield[x+1][y+1];
}

// showPixels
void showPixels()
{
     // show
   for (int z=0;z<5;z++) 
   {  
     for (int zz=0;zz<7;zz++)
     {
         // y / x
         // gamekit.set_pixel(z, zz, 0); // 0-15 / 15-20 blink
         gamekit.set_pixel(z, zz, screen[z][zz]); // 0-15 / 15-20 blink
      }
   }  
}

// invert gamescreen
void invertPixels()
{
     // show
   for (int z=0;z<5;z++) 
   {  
     for (int zz=0;zz<7;zz++)
     {
        int rgb=gamekit.get_pixel(z, zz);
        int newrgb=16-rgb; if (newrgb<0) newrgb=0;
         gamekit.set_pixel(z, zz, newrgb); // 0-15 / 15-20 blink
      }
   }  
}


// clearDirectScreen
void clearDirectScreen(int value)
{
     // show
   for (int z=0;z<5;z++) 
   {  
     for (int zz=0;zz<7;zz++)
     {
         gamekit.set_pixel(z, zz, value); // 0-15 / 15-20 blink
      }
   }  
}

/*  
    sound
    
*/
void tuneEat()
{
 gamekit.play_tone(392, 50, LOUD);  
}
void tuneWalk()
{
 gamekit.play_tone(392, 50, SILENT);  
}

void tuneClick()
{
 gamekit.play_tone(352, 50, LOUD);  
}

void tuneDie()
{
 gamekit.play_tone(264, 50, LOUD);  
}

void tuneNextLevel()
{
 gamekit.play_tone(396, 50, LOUD);  
}



/*

  DEBUG

*/


// shows a "matrix" 
void debugMatrix(int left, int right, int up, int down)
{
    Serial.println("");
    if (up==1) { Serial.print(" *"); } else { Serial.print(" X");  }
     Serial.println("");

    if (left==1) { Serial.print("*"); } else { Serial.print("X");  }
    Serial.print(" ");
    if (right==1) { Serial.print("*"); } else { Serial.print("X");  }
    Serial.println("");

    if (down==1) { Serial.print(" *"); } else { Serial.print(" X");  }
     Serial.println("");
  
}




